function GWLabelClass()
{
   super.init(GWLabelClass);
}
GWLabelClass.prototype = new GWBaseClass();
Object.registerClass("GWLabelClass",GWLabelClass);
GWLabelClass.prototype.init = function()
{
   this.padx = this.padx || 0;
   this.pady = this.pady || 0;
   this.buffer = this.buffer || 2;
   this.fontcolor_off = this.fontcolor_off != undefined ? this.fontcolor_off : 8421504;
   this.fontcolor_shadow = this.fontcolor_shadow != undefined ? this.fontcolor_shadow : 16777215;
};
GWLabelClass.prototype.alignLabel = function(a)
{
   if(a == "right")
   {
      this.label_mc._x = this.mask_mc._width - this.label_mc._width - this.padx;
   }
   else if(a == "center")
   {
      this.label_mc._x = Math.max(0,Math.round((this.width - this.label_mc._width) / 2));
   }
   else
   {
      this.label_mc._x = this.padx;
   }
   this.label_mc._y = Math.max(0,Math.round((this.height - this.label_mc._height) / 2));
   this.label_mc.x = this.label_mc._x;
   this.label_mc.y = this.label_mc._y;
};
GWLabelClass.prototype.gethtmlLabel = function()
{
   return this.label_mc.label_txt.htmlText;
};
GWLabelClass.prototype.getLabel = function()
{
   return this.label_mc.label_txt.text;
};
GWLabelClass.prototype.setLabelFormat = function(f)
{
   this.myFormat = f;
   this.setLabel(this.gethtmlLabel());
};
GWLabelClass.prototype.setLabel = function(t)
{
   this.width = this.width || this._width;
   this.height = this.height || this._height;
   if(!this.label_mc)
   {
      this.createEmptyMovieClip("label_mc",500);
      this.drawBox("mask_mc",501,0,0,this.width - this.padx,this.height - this.pady,0,0);
   }
   if(!this.myFormat)
   {
      this.myFormat = new TextFormat();
   }
   this.label_mc.createTextField("label_txt",2,0,0,this.width,this.height);
   if(this.useEmbedFonts)
   {
      this.label_mc.label_txt.embedFonts = true;
   }
   this.label_mc.label_txt.selectable = false;
   this.label_mc.label_txt.html = true;
   this.label_mc.label_txt.autoSize = "center";
   this.label_mc.label_txt.htmlText = t;
   this.myFormat.font = this.font != undefined ? this.font : "Tahoma";
   this.myFormat.size = this.fontsize || 11;
   this.myFormat.color = this.fontcolor;
   this.label_mc.label_txt.setTextFormat(this.myFormat);
   if(this.fitLabel)
   {
      this.mask_mc._width = this.width = Math.max(this.width,(!(this.labelpos == "left" || this.labelpos == "right") ? 0 : this.icon_mc._width) + this.label_mc._width + this.padx * 2);
      this.mask_mc._height = this.height = Math.max(this.height,(!(this.labelpos == "top" || this.labelpos == "bottom") ? 0 : this.icon_mc._height) + this.label_mc._height + this.pady * 2);
      this.setSize(this.width,this.height);
   }
   this.alignLabel(this.align);
   if(this.labelpos != undefined)
   {
      this.setLabelPlacement(this.labelpos);
   }
   this.setMask(this.mask_mc);
};
GWLabelClass.prototype.setLabelEnabled = function(f)
{
   if(f)
   {
      this.setLabelColor(this.fontcolor);
      this.label_mc.shadow_txt.text = "";
   }
   else
   {
      this.setLabelColor(this.fontcolor_off);
      if(this.fontcolor_shadow != undefined)
      {
         this.label_mc.createTextField("shadow_txt",0,0,0,this.width,this.height);
         this.label_mc.shadow_txt.autoSize = "left";
         this.label_mc.shadow_txt.selectable = false;
         this.label_mc.shadow_txt.html = true;
         this.label_mc.shadow_txt.htmlText = this.getLabel();
         this.myFormat.color = this.fontcolor_shadow;
         this.label_mc.shadow_txt.setTextFormat(this.myFormat);
      }
   }
};
GWLabelClass.prototype.setLabelColor = function(c)
{
   this.myFormat.color = c || 0;
   this.label_mc.label_txt.setTextFormat(this.myFormat);
};
GWLabelClass.prototype.setLabelPlacement = function(pos)
{
   this.labelpos = pos;
   this.valign = "center";
   this.align = "center";
   if(pos == "left")
   {
      this.align = "right";
      this.width = Math.max(this.width,this.label_mc._width + this.icon_mc._width + this.buffer);
      if(this.fitLabel)
      {
         this.setSize(this.width,this.height);
      }
      this.label_mc._x = this.icon_mc._x - this.label_mc._width - this.buffer;
      this.icon_mc._y = Math.round((this.height - this.icon_mc._height) / 2);
   }
   else if(pos == "right")
   {
      this.align = "left";
      this.width = Math.max(this.width,this.label_mc._width + this.icon_mc._width + this.buffer);
      if(this.fitLabel)
      {
         this.setSize(this.width,this.height);
      }
      this.label_mc._x = this.icon_mc._x + this.icon_mc._width + this.buffer;
      this.icon_mc._y = Math.round((this.height - this.icon_mc._height) / 2);
   }
   else if(pos == "top")
   {
      this.valign = "bottom";
      this.width = Math.max(this.width,this._width);
      this.height = Math.max(this.height,this.label_mc._height + this.icon_mc._height + this.buffer);
      if(this.fitLabel)
      {
         this.setSize(this.width,this.height);
      }
      this.label_mc._x = Math.max(0,Math.round((this.width - this.label_mc._width) / 2));
      this.label_mc._y = this.icon_mc._y - this.label_mc._height - this.buffer;
   }
   else if(pos == "bottom")
   {
      this.valign = "top";
      this.width = Math.max(this.width,this._width);
      this.height = Math.max(this.height,this.label_mc._height + this.icon_mc._height + this.buffer);
      if(this.fitLabel)
      {
         this.setSize(this.width,this.height);
      }
      this.label_mc._x = Math.max(0,Math.round((this.width - this.label_mc._width) / 2));
      this.label_mc._y = this.icon_mc._y + this.icon_mc._height + this.buffer;
   }
};
